//	This file is part of the "jQuery.Syntax" project, and is distributed under the MIT License.
//	Copyright (c) 2011 Samuel G. D. Williams. <http://www.oriontransfer.co.nz>
//	See <jquery.syntax.js> for licensing details.

if(!Syntax.styles["jquery.syntax.layout.list_scoll"]) {
	Syntax.styles["jquery.syntax.layout.list_scoll"]="jquery.syntax.layout.list_scroll.css";
	Syntax.getStyles(Syntax.root+Syntax.styles["jquery.syntax.layout.list_scoll"]);
}
Syntax.layouts.list_scroll = function(options, code, container) {
	var listTag = options.listTag || 'ol';

	var syntaxContainer = jQuery('<div class="syntax-container">');
	if(container.attr('title')) {
	  var titlebar=jQuery('<div class="titlebar">');
	  titlebar.append(container.attr('title'));
	  syntaxContainer.append(titlebar);
	}

	var list = jQuery('<' + listTag + ' class="syntax highlighted">'), line = 1, space = /^\s*$/;
	var toolbar = jQuery('<div class="toolbar">');
	
	var rawCode = container.clone();
	rawCode.addClass("raw syntax highlighted");
	
	// Source code
	code.children().each(function() {
		var li = document.createElement('li');
		li.className = "line ln" + line
		
		if (line % 2) {
			li.className += " alt";
		}
		
		if (line == 1) {
			li.className += " first"
		}
		
		var div = document.createElement('div');
		div.className = "source "  + this.className;
		
		div.appendChild(this);
		
		li.appendChild(div);
		list[0].appendChild(li);
		
		line = line + 1;
	});
	
	a = jQuery('<a href="#">View Raw Code</a>');
	a.click(function (event) {
		event.preventDefault();
		
		if (jQuery(list).is(':visible')) {
			rawCode.height(jQuery(list).height());
			jQuery(list).replaceWith(rawCode);
		} else {
			jQuery(rawCode).replaceWith(list);
		}
	});
	
	toolbar.append(a);
	toolbar.append('<a href="http://www.oriontransfer.co.nz/software/jquery-syntax" target="oriontransfer">?</a>');
	
	syntaxContainer.append(toolbar).append(list);
	if(container.css('max-height')!='none') {
  	list.height(container.css('max-height'));
  	return jQuery('<div class="scroll-container">').append(syntaxContainer);
	} else return syntaxContainer;
};
